'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObject = require('lodash/object');

var _placeholders = require('./placeholders');

var _placeholders2 = _interopRequireDefault(_placeholders);

var ReactFiller = _react2['default'].createClass({
  displayName: 'ReactFiller',

  /* eslint-disable key-spacing */
  propTypes: {
    children: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.node, _react2['default'].PropTypes.element]).isRequired,
    ready: _react2['default'].PropTypes.bool.isRequired,
    firstLaunchOnly: _react2['default'].PropTypes.bool,
    type: _react2['default'].PropTypes.oneOf(['text', 'media', 'textRow', 'rect', 'round']),
    rows: _react2['default'].PropTypes.number,
    color: _react2['default'].PropTypes.string,
    customPlaceholder: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.node, _react2['default'].PropTypes.element])
  },
  /* eslint-enable key-spacing */

  getDefaultProps: function getDefaultProps() {
    return {
      type: 'text',
      color: '#CDCDCD'
    };
  },

  getInitialState: function getInitialState() {
    return {
      ready: this.props.ready
    };
  },

  isReady: function isReady() {
    return this.props.firstLaunchOnly ? this.state.ready : this.props.ready;
  },

  getFiller: function getFiller() {
    if (this.props.customPlaceholder) {
      return this.props.customPlaceholder;
    }
    var Placeholder = _placeholders2['default'][this.props.type];
    var props = _lodashObject.omit(this.props, ['children', 'ready', 'firstLaunchOnly', 'type']);
    return _react2['default'].createElement(Placeholder, props);
  },

  render: function render() {
    return this.isReady() ? this.props.children : this.getFiller();
  },

  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (!this.state.ready) {
      this.setState({
        ready: nextProps.ready
      });
    }
  }

});

exports['default'] = ReactFiller;
module.exports = exports['default'];