'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextRow = require('./TextRow');

var _TextRow2 = _interopRequireDefault(_TextRow);

var widths = [97, 100, 94, 90, 98, 95, 98, 40];

var TextBlock = _react2['default'].createClass({
  displayName: 'TextBlock',

  propTypes: {
    rows: _react2['default'].PropTypes.number.isRequired,
    color: _react2['default'].PropTypes.string.isRequired,
    style: _react2['default'].PropTypes.object,
    className: _react2['default'].PropTypes.string
  },

  getDefaultProps: function getDefaultProps() {
    return {
      className: '',
      style: {}
    };
  },

  getRowStyle: function getRowStyle(i) {
    var rows = this.props.rows * 2 - 1;
    var style = {
      backgroundColor: this.props.color,
      maxHeight: 100 / rows + '%'
    };
    if (i % 2 === 0) {
      style.width = widths[(i / 2 + widths.length) % widths.length] + '%';
    }
    return style;
  },

  getRows: function getRows() {
    var _this = this;

    var rows = this.props.rows * 2 - 1;
    var range = Array.apply(null, { length: rows });
    return range.map(function (x, i) {
      return _react2['default'].createElement(_TextRow2['default'], { style: _this.getRowStyle(i), invisible: i % 2 > 0, key: i });
    });
  },

  render: function render() {
    this.props.style.width = '100%';
    return _react2['default'].createElement(
      'div',
      { className: 'text-block ' + this.props.className, style: this.props.style },
      this.getRows()
    );
  }

});

exports['default'] = TextBlock;
module.exports = exports['default'];