'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObject = require('lodash/object');

var TextRow = _react2['default'].createClass({
  displayName: 'TextRow',

  /* eslint-disable key-spacing */
  propTypes: {
    invisible: _react2['default'].PropTypes.bool,
    className: _react2['default'].PropTypes.string,
    color: _react2['default'].PropTypes.string,
    style: _react2['default'].PropTypes.object
  },
  /* eslint-enable key-spacing */

  getDefaultProps: function getDefaultProps() {
    return {
      className: '',
      style: {}
    };
  },

  render: function render() {
    var defaultStyles = {
      width: '100%',
      height: 8,
      maxHeight: this.props.maxHeight,
      backgroundColor: this.props.color
    };
    var style = _lodashObject.assign(defaultStyles, this.props.style);
    if (this.props.invisible) {
      style.width = 0;
    }

    var invisible = this.props.invisible ? 'invisible' : '';
    return _react2['default'].createElement('div', { className: 'text-row ' + this.props.className + ' ' + invisible, style: style });
  }

});

exports['default'] = TextRow;
module.exports = exports['default'];